// ReadWriteLock (from class)
// Assignment 2
// CSC 375 - Lea
// Jacob Peck - 20111015

import java.util.concurrent.locks.ReentrantLock;
import java.util.concurrent.locks.Condition;

public class ReadWriteLock {
  int activeReaders;
  int activeWriters;
  int pendingReaders;
  int pendingWriters;
  
  final ReentrantLock lock = new ReentrantLock();
  final Condition canRead = lock.newCondition();
  final Condition canWrite = lock.newCondition();

  void readLock() throws InterruptedException {
    lock.lock();
    try {
      while(activeWriters != 0) {
        ++pendingReaders;
        canRead.await();
        --pendingReaders;
      }
      ++activeReaders;
    } finally {
      lock.unlock();
    }
  }

  void writeLock() {
    lock.lock();
    try {
      while(activeReaders != 0 || activeWriters != 0) {
        ++pendingWriters;
        canWrite.awaitUninterruptibly();
        --pendingWriters;
      }
      assert activeReaders == 0;
      activeWriters = 1;
    } finally {
      lock.unlock();
    }
  }

  void unlockWrite() throws IllegalMonitorStateException {
    lock.lock();
    try {
      if(activeWriters == 0) throw new IllegalMonitorStateException();
      activeWriters = 0;
      if(pendingWriters != 0) 
        canWrite.signal();
      else
        canRead.signalAll();
    } finally {
      lock.unlock();
    }
  }
  
  void unlockRead() throws IllegalMonitorStateException {
    lock.lock();
    try {
      if(activeReaders == 0) throw new IllegalMonitorStateException();
      if(--activeReaders == 0){
        if(pendingWriters != 0)
          canWrite.signal();
        else
          canRead.signalAll();
      }
    } finally {
      lock.unlock();
    }
  }
}